//+------------------------------------------------------------------+
//|                                ChartBackgroundColorByMA_BTEv.mq5 |
//|                                          Copyright 2022 mql5.com |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2022 mql5.com"
#property link      "https://www.mql5.com"
#property version   "1.00"
#property indicator_plots 0
#property indicator_chart_window

enum enMethod {
MovingAverage,    // Moving Average
MACD              // MACD Signal Main
};

input enMethod           IndicatorMethod    = MovingAverage;
input color              BullishColor       = clrDarkGreen;
input color              BearishColor       = clrMaroon; 
input string             Moving_Average_Section = "";
input uint               MaPeriod           = 9;
input ENUM_MA_METHOD     MaMethod           = MODE_SMA;
input ENUM_APPLIED_PRICE MaPrice            = PRICE_CLOSE; 
input string             MACD_Section       = "";     
input uint               Fast_EMA           = 12; 
input uint               Slow_EMA           = 26; 
input uint               MACD_SMA           = 9;
input ENUM_APPLIED_PRICE MACDPrice          = PRICE_CLOSE;
input uint               Bar                = 1; 

double ma,main,signal;
double MA[],MAIN[],SIGNAL[];
int MAHndl,MACDHndl;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
                MAHndl=iMA(_Symbol,_Period,MaPeriod,0,MaMethod,MaPrice);
                MACDHndl=iMACD(_Symbol,_Period,Fast_EMA,Slow_EMA,MACD_SMA,MACDPrice);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
               double Bid = SymbolInfoDouble(_Symbol,SYMBOL_BID);
               double Ask = SymbolInfoDouble(_Symbol,SYMBOL_ASK);
                if(IndicatorMethod==MovingAverage)
                 {
                CopyBuffer(MAHndl,0,Bar,Bar+1,MA);
                ma=MA[Bar];
                if(Bid>ma)
                ChartSetInteger(0,CHART_COLOR_BACKGROUND,BullishColor);
                if(Bid<=ma)
                ChartSetInteger(0,CHART_COLOR_BACKGROUND,BearishColor);
                 }
                if(IndicatorMethod==MACD)
                 {
                CopyBuffer(MACDHndl,0,Bar,Bar+1,MAIN);
                CopyBuffer(MACDHndl,1,Bar,Bar+1,SIGNAL);
                signal=SIGNAL[Bar];
                main=MAIN[Bar];
                if(signal<=main)
                ChartSetInteger(0,CHART_COLOR_BACKGROUND,BullishColor);
                if(signal>main)
                ChartSetInteger(0,CHART_COLOR_BACKGROUND,BearishColor);
                 }
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
